[emacs] Update submodule + rework install script

This commit is contained in:
nemunaire 2015-06-29 15:21:03 +02:00
parent 7a0ca44f5d
commit 8e69908166
2 changed files with 70 additions and 42 deletions

@ -1 +1 @@
Subproject commit 6efad95dbab78f4bbed3c95b96abb766c1a7a392
Subproject commit 5998ca087f2475a5c5c01f30334320af750e6fd0

View File

@ -1,12 +1,21 @@
#!/bin/sh
if [ ${0:0:1} == "/" ]
then
SOURCE=$(dirname $0)/
else
SOURCE=$(dirname `pwd`/$0)/
fi
DESTINATION=~
die() {
echo "$1" >&2
exit 1
}
in_list() {
for i in $1
do
[ "$i" == "$2" ] && return 0
done
return 1
}
cd $(dirname "$0")
[ -n "${DESTDIR}" ] || DESTDIR=~
if [ "$1" == "install" ] || [ "$1" == "link" ] || [ "$1" == "links" ]
then
@ -14,8 +23,9 @@ then
BIN="ln -s"
elif [ "$1" == "update" ] || [ "$1" == "pull" ]
then
cd $SOURCE
git pull --recurse-submodules=yes `git remote | head -n 1`
git stash &&
git pull --recurse-submodules=yes --rebase `git remote | head -n 1` &&
git stash pop
exit $?
elif [ "$1" == "remove" ] || [ "$1" == "uninstall" ]
then
@ -42,39 +52,57 @@ else
exit 0
fi
cd "$SOURCE"
git submodule init &&
git submodule update --recursive
git submodule update --init --recursive || die "Unable to update submodules"
IGNORE_FILES=".
..
.git
.gitmodules
install.sh"
TMPERR=`mktemp`
for f in `ls -a "$SOURCE"`
do
if [ "$f" != "." ] && [ "$f" != ".." ] && [ "$f" != ".git" ] &&
[ "$f" != ".gitmodules" ] && [ "$f" != "install.sh" ]
then
if [ "$REMOVE" -eq 0 ]; then
echo -ne "Removing $f ...\t"
if [ -L "$DESTINATION/$f" ]; then
$BIN "$DESTINATION/$f" >&2 2> "$TMPERR"
if [ $? == 0 ]; then echo -e "\e[32mdone\e[0m"; else echo -e "\e[31;01mfail\e[0m"; fi
cat "$TMPERR"
install_dir() {
for f in `ls -a "$1"`
do
if ! in_list "$IGNORE_FILES" "$f"
then
if [ "$REMOVE" -eq 0 ]; then
echo -ne "Removing $1/$f ...\t"
if [ -L "${DESTDIR}/$1/$f" ]; then
$BIN "${DESTDIR}/$1/$f" >&2 2> "$TMPERR"
if [ $? == 0 ]; then echo -e "\e[32mdone\e[0m"; else echo -e "\e[31;01mfail\e[0m"; fi
cat "$TMPERR"
else
echo -e "Not installed"
fi
else
echo -e "Not installed"
echo -ne "Installing $1/$f ...\t"
# Alignment
[ $((${#f} + ${#1})) -lt 8 ] && echo -en "\t"; [ $((${#f} + ${#1})) -lt 16 ] && echo -en "\t"
if [ -L "${DESTDIR}/$1/$f" ]
then
echo -e "\e[36mAlready installed\e[0m"
elif [ -d "${DESTDIR}/$1/$f" ] && [ -d "$1/$f" ]
then
echo -e "\e[33mExistant directory\e[0m"
install_dir "$1/$f"
elif [ -e "${DESTDIR}/$1/$f" ]
then
echo -e "\e[35mAlready exists\e[0m"
else
if $BIN "$(pwd)/$1/$f" "${DESTDIR}/$1/$f" >&2 2> "$TMPERR"
then
echo -e "\e[32mdone\e[0m"
else
echo -e "\e[31;01mfail\e[0m"
fi
cat "$TMPERR"
fi
fi
else
echo -ne "Installing $f ...\t"
if [ ${#f} -lt 9 ]; then echo -en "\t"; fi
if [ -L "$DESTINATION/$f" ]
then
echo -e "\e[36mAlready installed\e[0m"
elif [ -e "$DESTINATION/$f" ]
then
echo -e "\e[35mAlready exists\e[0m"
else
$BIN "$SOURCE/$f" "$DESTINATION/$f" >&2 2> "$TMPERR"
if [ $? == 0 ]; then echo -e "\e[32mdone\e[0m"; else echo -e "\e[31;01mfail\e[0m"; fi
cat "$TMPERR"
fi
fi
fi
done
fi
done
}
install_dir .
rm "${TMPERR}"